
void edit_properties(GtkWidget *widget, gpointer *data)
{
   GtkWidget *menu_separator;
   change_dialog_window = gtk_window_new(GTK_WINDOW_DIALOG);
   gtk_container_set_border_width(GTK_CONTAINER(change_dialog_window), 10);   

   main_dialog_box = gtk_vbox_new(FALSE, 0);
   gtk_container_add(GTK_CONTAINER(change_dialog_window), main_dialog_box);
   gtk_widget_show(main_dialog_box);

   edited_dialog_box = gtk_hbox_new(FALSE, 10);
   gtk_box_pack_start(GTK_BOX(main_dialog_box), edited_dialog_box, TRUE, TRUE, 0);
   gtk_widget_show(edited_dialog_box);

   edited_list_window = gtk_scrolled_window_new (0, 0);
   gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(edited_list_window), GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS);
   gtk_widget_set_usize(GTK_WIDGET(edited_list_window), 250, 350);
   gtk_box_pack_start(GTK_BOX(edited_dialog_box), edited_list_window, TRUE, TRUE, 0);
   gtk_widget_show(edited_list_window);

   edited_list = gtk_clist_new(2);
   gtk_clist_set_column_title(GTK_CLIST(edited_list), 0, "Item");
   gtk_clist_set_column_title(GTK_CLIST(edited_list), 1, "Value");
   gtk_clist_set_selection_mode(GTK_CLIST(edited_list), GTK_SELECTION_SINGLE);
   gtk_clist_set_shadow_type(GTK_CLIST(edited_list), GTK_SHADOW_ETCHED_IN);
   gtk_clist_set_column_justification(GTK_CLIST(edited_list), 0, GTK_JUSTIFY_LEFT);
   gtk_clist_set_row_height(GTK_CLIST(edited_list), 15);
   gtk_container_add(GTK_CONTAINER(edited_list_window), edited_list);
   gtk_clist_column_titles_show(GTK_CLIST(edited_list));
   gtk_clist_set_column_width (GTK_CLIST(edited_list), 0, 100);
   gtk_widget_show(edited_list);
   gtk_signal_connect(GTK_OBJECT(edited_list), "select_row", GTK_SIGNAL_FUNC(set_cur_sel), 0);
   gtk_signal_connect(GTK_OBJECT(edited_list), "unselect_row", GTK_SIGNAL_FUNC(set_no_sel), 0);

   gtk_editable_delete_text(GTK_EDITABLE(cur_file->item_text), 0, -1);
   build_props(edited_list, cur_file->item_text, cur_file->tempfile);

   edit_buttons_dialog_box = gtk_vbox_new(TRUE, 5);
   gtk_box_pack_start(GTK_BOX(edited_dialog_box), edit_buttons_dialog_box, TRUE, FALSE, 0);
   gtk_widget_show(edit_buttons_dialog_box);

   moveup_button = gtk_button_new_with_label("Move Up");
   gtk_box_pack_start(GTK_BOX(edit_buttons_dialog_box), moveup_button, FALSE, TRUE, 15);   
   gtk_signal_connect(GTK_OBJECT(moveup_button), "clicked", GTK_SIGNAL_FUNC(move_property_up), 0);
   gtk_widget_show(moveup_button);

   movedown_button = gtk_button_new_with_label("Move Down");
   gtk_box_pack_start(GTK_BOX(edit_buttons_dialog_box), movedown_button, FALSE, TRUE, 15);   
   gtk_signal_connect(GTK_OBJECT(movedown_button), "clicked", GTK_SIGNAL_FUNC(move_property_down), 0);
   gtk_widget_show(movedown_button);

   new_button = gtk_button_new_with_label("New Property");
   gtk_box_pack_start(GTK_BOX(edit_buttons_dialog_box), new_button, FALSE, TRUE, 15);   
   gtk_signal_connect(GTK_OBJECT(new_button), "clicked", GTK_SIGNAL_FUNC(new_property), 0);
   gtk_widget_show(new_button);

   edit_button = gtk_button_new_with_label("Edit Property");
   gtk_box_pack_start(GTK_BOX(edit_buttons_dialog_box), edit_button, FALSE, TRUE, 15);   
   gtk_signal_connect(GTK_OBJECT(edit_button), "clicked", GTK_SIGNAL_FUNC(edit_property), 0);
   gtk_widget_show(edit_button);

   del_button = gtk_button_new_with_label("Delete Property");
   gtk_box_pack_start(GTK_BOX(edit_buttons_dialog_box), del_button, FALSE, TRUE, 15);   
   gtk_signal_connect(GTK_OBJECT(del_button), "clicked", GTK_SIGNAL_FUNC(del_property), 0);
   gtk_widget_show(del_button);

   menu_separator = gtk_hseparator_new();
   gtk_box_pack_start (GTK_BOX(main_dialog_box), menu_separator, FALSE, FALSE, 10);
   gtk_widget_show (menu_separator);

   buttons_box = gtk_hbox_new(TRUE, 0);
   gtk_box_pack_end(GTK_BOX(main_dialog_box), buttons_box, FALSE, FALSE, 5);
   gtk_widget_show(buttons_box);

   ok_button = gtk_button_new_with_label(" OK ");
   gtk_box_pack_start(GTK_BOX(buttons_box), ok_button, FALSE, TRUE, 15);
   gtk_signal_connect(GTK_OBJECT(ok_button), "clicked", GTK_SIGNAL_FUNC(save_properties), 0);
   gtk_signal_connect(GTK_OBJECT(ok_button), "clicked", GTK_SIGNAL_FUNC(kill_widget), GTK_OBJECT(change_dialog_window));
   gtk_widget_show(ok_button);

   cancel_button = gtk_button_new_with_label("Cancel");
   gtk_box_pack_start(GTK_BOX(buttons_box), cancel_button, FALSE, TRUE, 15);   
   gtk_signal_connect(GTK_OBJECT(cancel_button), "clicked", GTK_SIGNAL_FUNC(kill_widget), GTK_OBJECT(change_dialog_window));
   gtk_widget_show(cancel_button);

   gtk_clist_select_row(GTK_CLIST(edited_list), 0, 0);
   gtk_widget_show(change_dialog_window);
}

void set_cur_sel(GtkWidget *widget, gint row, gint column, GdkEventButton *event, gpointer data)
{
   cur_sel_list_row = row;
   cur_sel_list_col = column;

   gboolean is_name = FALSE;
   gchar *cur_text;
   gtk_clist_get_text(GTK_CLIST(edited_list), cur_sel_list_row, 0, &cur_text);

   if((strcmp(cur_text, "name")) == 0)
      is_name = TRUE;

   if(cur_sel_list_row > 0)
      gtk_widget_set_sensitive(moveup_button, 1);
   else
      gtk_widget_set_sensitive(moveup_button, 0);

   if(cur_sel_list_row < (total_props - 1))
      gtk_widget_set_sensitive(movedown_button, 1);         
   else
      gtk_widget_set_sensitive(movedown_button, 0);

   if(total_props > 15)
      gtk_widget_set_sensitive(new_button, 0);
   else
      gtk_widget_set_sensitive(new_button, 1);   

   if(is_name == TRUE)
   {
      gtk_widget_set_sensitive(del_button, 0);   
      gtk_widget_set_sensitive(edit_button, 0);
   }
   else
   {
      gtk_widget_set_sensitive(del_button, 1);   
      gtk_widget_set_sensitive(edit_button, 1);      
   }
}


void set_no_sel(GtkWidget *widget, gint row, gint column, GdkEventButton *event, gpointer data)
{
   cur_sel_list_row = 17;
   cur_sel_list_col = 17;
   gtk_widget_set_sensitive(moveup_button, 0);
   gtk_widget_set_sensitive(movedown_button, 0);

   if(total_props > 15)
      gtk_widget_set_sensitive(new_button, 0);
   else
      gtk_widget_set_sensitive(new_button, 1);   

   gtk_widget_set_sensitive(edit_button, 0);
   gtk_widget_set_sensitive(del_button, 0);   
}

void move_property_up(GtkWidget *widget, gpointer *data)
{
   gtk_clist_swap_rows(GTK_CLIST(edited_list), cur_sel_list_row, cur_sel_list_row - 1);
   gtk_clist_select_row(GTK_CLIST(edited_list), cur_sel_list_row - 1, 0);
}

void move_property_down(GtkWidget *widget, gpointer *data)
{
   gtk_clist_swap_rows(GTK_CLIST(edited_list), cur_sel_list_row, cur_sel_list_row + 1);
   gtk_clist_select_row(GTK_CLIST(edited_list), cur_sel_list_row + 1, 0);
}

void new_property(GtkWidget *widget, gpointer *data)
{
   change_dialog_window = gtk_window_new(GTK_WINDOW_DIALOG);
   gtk_window_set_title(GTK_WINDOW(change_dialog_window), "New Property");
   gtk_widget_set_usize(GTK_WIDGET(change_dialog_window), 550,135);
   gtk_container_set_border_width(GTK_CONTAINER(change_dialog_window), 10);   
   main_dialog_box = gtk_vbox_new(FALSE, 0);
   gtk_container_add(GTK_CONTAINER(change_dialog_window), main_dialog_box);
   gtk_widget_show(main_dialog_box);

   entry_dialog_box = gtk_hbox_new(FALSE, 0);
   gtk_box_pack_start(GTK_BOX(main_dialog_box), entry_dialog_box, FALSE, FALSE, 0);
   gtk_widget_show(entry_dialog_box);
   dialog_label = gtk_label_new("Propery name:");
   gtk_box_pack_start(GTK_BOX(entry_dialog_box), dialog_label, FALSE, FALSE, 0);
   gtk_widget_show(dialog_label);   
   dialog_entry = gtk_entry_new();
   gtk_box_pack_start(GTK_BOX(entry_dialog_box), dialog_entry, FALSE, FALSE, 0);
   gtk_widget_show(dialog_entry);   

   dialog_label2 = gtk_label_new("Propery value:");
   gtk_box_pack_start(GTK_BOX(entry_dialog_box), dialog_label2, FALSE, FALSE, 5);
   gtk_widget_show(dialog_label2);   
   dialog_entry2 = gtk_entry_new();
   gtk_box_pack_start(GTK_BOX(entry_dialog_box), dialog_entry2, FALSE, FALSE, 5);
   gtk_widget_show(dialog_entry2);   

   buttons_box = gtk_hbox_new(FALSE, 0);
   gtk_box_pack_end(GTK_BOX(main_dialog_box), buttons_box, FALSE, FALSE, 5);
   gtk_widget_show(buttons_box);

   cancel_button = gtk_button_new_with_label("Cancel");
   gtk_box_pack_end(GTK_BOX(buttons_box), cancel_button, FALSE, FALSE, 5);   
   gtk_signal_connect(GTK_OBJECT(cancel_button), "clicked", GTK_SIGNAL_FUNC(kill_widget), GTK_OBJECT(change_dialog_window));
   gtk_widget_show(cancel_button);

   ok_button = gtk_button_new_with_label(" OK ");
   gtk_box_pack_end(GTK_BOX(buttons_box), ok_button, FALSE, FALSE, 5);
   gtk_signal_connect(GTK_OBJECT(ok_button), "clicked", GTK_SIGNAL_FUNC(do_new_prop), 0);
   gtk_signal_connect(GTK_OBJECT(ok_button), "clicked", GTK_SIGNAL_FUNC(kill_widget), GTK_OBJECT(change_dialog_window));
   gtk_widget_show(ok_button);
   gtk_widget_show(change_dialog_window);
}

void do_new_prop(GtkWidget *widget, gpointer *data)
{
   int new_row = 0;
   gchar *ptrs[2];
   ptrs[0] = gtk_entry_get_text(GTK_ENTRY(dialog_entry));
   ptrs[1] = gtk_entry_get_text(GTK_ENTRY(dialog_entry2));
   if(cur_sel_list_row == 17)
      new_row = gtk_clist_append(GTK_CLIST(edited_list), ptrs);
   else
      new_row = gtk_clist_insert(GTK_CLIST(edited_list), cur_sel_list_row, ptrs);

   total_props++;
   gtk_clist_select_row(GTK_CLIST(edited_list), new_row, 0);
}

void edit_property(GtkWidget *widget, gpointer *data)
{
   change_dialog_window = gtk_window_new(GTK_WINDOW_DIALOG);
   gtk_window_set_title(GTK_WINDOW(change_dialog_window), "New Property");
   gtk_widget_set_usize(GTK_WIDGET(change_dialog_window), 550,135);
   gtk_container_set_border_width(GTK_CONTAINER(change_dialog_window), 10);   
   main_dialog_box = gtk_vbox_new(FALSE, 0);
   gtk_container_add(GTK_CONTAINER(change_dialog_window), main_dialog_box);
   gtk_widget_show(main_dialog_box);

   entry_dialog_box = gtk_hbox_new(FALSE, 0);
   gtk_box_pack_start(GTK_BOX(main_dialog_box), entry_dialog_box, FALSE, FALSE, 0);
   gtk_widget_show(entry_dialog_box);
   dialog_label = gtk_label_new("Propery name:");
   gtk_box_pack_start(GTK_BOX(entry_dialog_box), dialog_label, FALSE, FALSE, 5);
   gtk_widget_show(dialog_label);   
   dialog_entry = gtk_entry_new();
   gtk_box_pack_start(GTK_BOX(entry_dialog_box), dialog_entry, FALSE, FALSE, 5);
   gtk_widget_show(dialog_entry);   

   gchar *cur_text;
   gtk_clist_get_text(GTK_CLIST(edited_list), cur_sel_list_row, 0, &cur_text);
   gtk_entry_set_text(GTK_ENTRY(dialog_entry), cur_text);

   dialog_label2 = gtk_label_new("Propery value:");
   gtk_box_pack_start(GTK_BOX(entry_dialog_box), dialog_label2, FALSE, FALSE, 5);
   gtk_widget_show(dialog_label2);   
   dialog_entry2 = gtk_entry_new();
   gtk_box_pack_start(GTK_BOX(entry_dialog_box), dialog_entry2, FALSE, FALSE, 5);
   gtk_widget_show(dialog_entry2);   

   gtk_clist_get_text(GTK_CLIST(edited_list), cur_sel_list_row, 1, &cur_text);
   gtk_entry_set_text(GTK_ENTRY(dialog_entry2), cur_text);

   buttons_box = gtk_hbox_new(FALSE, 0);
   gtk_box_pack_end(GTK_BOX(main_dialog_box), buttons_box, FALSE, FALSE, 5);
   gtk_widget_show(buttons_box);

   cancel_button = gtk_button_new_with_label("Cancel");
   gtk_box_pack_end(GTK_BOX(buttons_box), cancel_button, FALSE, FALSE, 5);   
   gtk_signal_connect(GTK_OBJECT(cancel_button), "clicked", GTK_SIGNAL_FUNC(kill_widget), GTK_OBJECT(change_dialog_window));
   gtk_widget_show(cancel_button);

   ok_button = gtk_button_new_with_label(" OK ");
   gtk_box_pack_end(GTK_BOX(buttons_box), ok_button, FALSE, FALSE, 5);
   gtk_signal_connect(GTK_OBJECT(ok_button), "clicked", GTK_SIGNAL_FUNC(do_edit_prop), 0);
   gtk_signal_connect(GTK_OBJECT(ok_button), "clicked", GTK_SIGNAL_FUNC(kill_widget), GTK_OBJECT(change_dialog_window));
   gtk_widget_show(ok_button);
   gtk_widget_show(change_dialog_window);

}

void do_edit_prop(GtkWidget *widget, gpointer *data)
{
   gtk_clist_set_text(GTK_CLIST(edited_list), cur_sel_list_row, 0, gtk_entry_get_text(GTK_ENTRY(dialog_entry)));
   gtk_clist_set_text(GTK_CLIST(edited_list), cur_sel_list_row, 1, gtk_entry_get_text(GTK_ENTRY(dialog_entry2)));
}

void del_property(GtkWidget *widget, gpointer *data)
{
   if(total_props > 1)
   {
      gint temp = cur_sel_list_row;
      gtk_clist_remove(GTK_CLIST(edited_list), cur_sel_list_row);
      total_props--;
      gtk_clist_select_row(GTK_CLIST(edited_list), temp - 1, 0);
   }
}


void save_properties(GtkWidget *widget, gpointer *data)
{
   char input[1024];
   char buffer[256] = "";
   gchar *cur_text;
   char *char_ptr;

   ifstream Input;
   ofstream Output;
   Input.open(cur_file->tempfile);
   Output.open(tempfile);

   GtkLabel *label;
   gchar *label_text;
   label = GTK_LABEL(GTK_BIN(cur_file->cur_selected_item)->child);
   gtk_label_get(label, &label_text);
   strcat(buffer, "name=[");
   strcat(buffer, label_text);
   strcat(buffer, "]");
   
   while(Input.getline(input, 1024) != NULL)
   {
      if((strstr(input, buffer)) != NULL)
      {
         if(cur_file->cur_selected_tree == NULL)
	    Output << "<TreeItem ";
	 else
	    Output << "<Tree ";
         for(int i = 0; i < total_props; i++)
	 {
            gtk_clist_get_text(GTK_CLIST(edited_list), i, 0, &cur_text);
            Output << cur_text << "=[";
	    gtk_clist_get_text(GTK_CLIST(edited_list), i, 1, &cur_text);
            Output << cur_text << "] ";	 
	 }
         Output << ">" << endl;
      }
      else
      {
         Output << input << endl;
      }
   }
   Input.close();
   Output.close();
   copy_file(tempfile, cur_file->tempfile);
   GtkWidget *temp = cur_file->cur_selected_item;
   gtk_tree_item_deselect(GTK_TREE_ITEM(cur_file->cur_selected_item));
   cur_file->saved = FALSE;
   gtk_tree_item_select(GTK_TREE_ITEM(temp));
}      
